"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const core_1 = require("../core");
const command = {
    name: 'hello',
    usage: 'hello <name> [options]',
    description: 'Hello command',
    alias: 'hi',
    // hidden: true,
    options: {
        lang: {
            type: 'string',
            alias: 'l',
            default: 'en',
            description: 'message language'
        },
        debug: {
            type: 'boolean',
            alias: 'd',
            description: 'debug mode'
        }
    },
    action: (ctx) => __awaiter(this, void 0, void 0, function* () {
        if (!ctx.primary) {
            return core_1.missingArgument('name');
        }
        if (ctx.options.lang === 'en') {
            core_1.logger.success(`Hey! ${ctx.primary}~`);
        }
        else if (ctx.options.lang === 'zh') {
            core_1.logger.success(`嘿！${ctx.primary}`);
        }
        if (ctx.options.debug) {
            core_1.logger.debug(ctx);
        }
    })
};
exports.default = command;
