"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const path_1 = require("path");
const minimist = require("minimist");
const minimist_options_1 = require("minimist-options");
/**
 * parse context from cli argv
 * @param argv cli argv
 * @param opts command options
 */
exports.parse = (argv, opts) => __awaiter(this, void 0, void 0, function* () {
    opts = opts || {};
    // mount package.json
    // eslint-disable-next-line @typescript-eslint/no-var-requires
    const pkg = require('../../package.json');
    // cli brand name
    const brand = typeof pkg.bin === 'string'
        ? path_1.basename(pkg.bin, '.js')
        : Object.keys(pkg.bin)[0];
    // parse argv by minimist
    const options = minimist(argv, minimist_options_1.default(opts));
    // row input args
    const input = options._;
    // extract arguments
    const [primary, secondary, thirdly, fourthly, ...extras] = input;
    // excluding aliases
    Object.values(opts).forEach(item => {
        if (typeof item !== 'string' && item.alias) {
            if (typeof item.alias === 'string') {
                delete options[item.alias];
            }
            else {
                item.alias.forEach(a => delete options[a]);
            }
        }
    });
    // excluding arguments
    delete options._;
    // return context
    return {
        brand,
        primary,
        secondary,
        thirdly,
        fourthly,
        extras,
        input,
        options,
        pkg
    };
});
