"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const helpers_1 = require("./helpers");
/**
 * Throw unknown command error.
 * @param name command name
 * @param fallback fallback command tip
 */
exports.unknownCommand = (name, fallback = '[bin] --help') => {
    helpers_1.logger.error('Unknown command: `%s`.', name);
    helpers_1.logger.error('Type `%s` to view all commands.', fallback);
    process.exit(1);
};
/**
 * Throw missing option error.
 * @param name argument name
 */
exports.missingArgument = (name) => {
    helpers_1.logger.error('Missing required argument: `<%s>`.', name);
    process.exit(1);
};
// export const unknownOption = (flag) => {
//   if (this._allowUnknownOption) return
//   console.error('Unknown option: `%s`.', chalk.yellow(flag))
//   process.exit(1)
// }
// export const missingArgument = (name) => {
//   console.error('Missing required argument: `%s`.', chalk.yellow(`<${name}>`))
//   process.exit(1)
// }
// export const optionMissingArgument = (option, flag) => {
//   if (flag) {
//     console.error('Missing required argument for option: `%s`, got `%s`', chalk.yellow(option.flags), chalk.yellow(flag))
//   } else {
//     console.error('Missing required argument for option: `%s`.', chalk.yellow(option.flags))
//   }
//   process.exit(1)
// }
// export const variadicArgNotLast = (name) => {
//   console.error('Variadic arguments must be last: `%s`.', chalk.yellow(name))
//   process.exit(1)
// }
