"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const loader_1 = require("./loader");
const context_1 = require("./context");
const invoker_1 = require("./invoker");
const defaultCommands = ['default', 'help', 'version'];
exports.run = (argv) => __awaiter(this, void 0, void 0, function* () {
    // default argv
    argv = argv || process.argv.slice(2);
    // extract command name and extra args
    const [name, ...extras] = argv;
    // load command by name
    const cmd = yield loader_1.load(name);
    // default command args
    if (defaultCommands.includes(cmd.name)) {
        extras.unshift(name);
    }
    // parse cli context
    const ctx = yield context_1.parse(extras, cmd.options);
    // invoke command
    return yield invoker_1.invoke(cmd, ctx);
});
