"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const lodash_1 = require("lodash");
const imports = {};
/**
 * Register helpers
 * @param helpers helper
 */
exports.registerHelpers = (helpers) => {
    Object.assign(imports, helpers);
};
/**
 * Render a template string as lodash template
 * @param input Template string
 * @param data Template data
 * @param options Template options
 * @return Render result
 */
exports.render = (input, data, options) => {
    options = Object.assign({ imports }, options);
    const compiled = lodash_1.template(input, options);
    return compiled(data);
};
